<?php
namespace webdevstudios;

function woo_product_cat_algolia_assets() {
	if ( ! is_product_category() && ! is_shop() ) {
		return;
	}

	// Javascript
	wp_enqueue_script( 'algolia-instantsearch' );

	// Stylesheets
	wp_enqueue_style( 'algolia-autocomplete' );
	wp_enqueue_style( 'algolia-instantsearch' );

	global $wp_query;

	if ( empty( $wp_query->query['product_cat'] ) ) {
		return;
	}
	$term_parts       = explode( '/', $wp_query->query['product_cat'] );
	$results['terms'] = [];
	foreach ( $term_parts as $part ) {
		$term               = get_term_by( 'slug', $part, 'product_cat' );
		$results['terms'][] = $term->name;
	}
	wp_add_inline_script( 'algolia-instantsearch', 'const woo_algolia_queried_terms = \'' . json_encode( $results ) . '\'; ' );
}
add_action( 'wp_enqueue_scripts', __NAMESPACE__ . '\woo_product_cat_algolia_assets' );
