<?php
namespace webdevstudios;

/*
 * Add the SKU to be one of the attributes to search through for a provided query.
 */
function amend_posts_products_and_searchable_settings( $settings ) {

	$settings['searchableAttributes'][] = 'unordered(sku)';

	// Prevents 40025 from being considered when 40026 was the query.
	$settings['disableTypoToleranceOnAttributes'][] = 'sku';
	// Prevents cases where searching "400" would turn up both "40025" and "40026" when "400" is a valid complete SKU
	$settings['disablePrefixOnAttributes'][]        = 'sku';

	return $settings;
}
add_filter( 'algolia_posts_product_index_settings', __NAMESPACE__ . '\amend_posts_products_and_searchable_settings' );
add_filter( 'algolia_searchable_posts_index_settings', __NAMESPACE__ . '\amend_posts_products_and_searchable_settings' );
